setInfos(3, "SexPuzzles", "Not a guided scenario script, just an erotic puzzle game. Complete it to discover a girl!",
			"Wololo", "completed", -13057, "en", ["game"])

setImage("sexpuzzles/Title.png")
show("")

if (loadBoolean("sexpuzzles.runBefore") == null) {
	for ( i in 1..10 ) {
		save("sexpuzzles.highscore"+i, ( 750 + (i*250) ) )
		save("sexpuzzles.highscoreName"+i, "John Doe")
	}
}
save("sexpuzzles.runBefore", true)

def action = getSelectedValue("", ["New Game", "Highscores", "Exit"] )

while (action < 2) {

if (action == 1) {
	// Show Highscores
	def scores = "# - Score - Name\n"
	for ( i in 1..10 ) 
		scores += i + " - " + loadInteger("sexpuzzles.highscore"+i) + " - " +  loadString("sexpuzzles.highscoreName"+i) + '\n'
	
	show(scores)
	showButton("Ok")
	show("")
}

else {
	// New Game
	def pieces = []
	def blank = 0

	for (i in 0..15) pieces += i

	def right = 0
	def up = 1
	def left = 2
	def down = 3

	def goDir = [ [ 1, null, null, 4], [2, null, 0, 5], [3, null, 1, 6], [null, null, 2, 7],
                  [5, 0, null, 8], [6, 1, 4, 9], [7, 2, 5, 10], [null, 3, 6, 11],
                  [9, 4, null, 12], [10, 5, 8, 13], [11, 6, 9, 14], [null, 7, 10, 15],
				  [13, 8, null, null], [14, 9, 12, null], [15, 10, 13, null], [null, 11, 14, null] ]

	def frameBuffer = new java.awt.image.BufferedImage(480, 480, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = frameBuffer.getGraphics()
	
	def bg = javax.imageio.ImageIO.read(new File("images/sexpuzzles/bg.png"))
	def piecePic = []
	
	def randomCode = getRandom(3)
	if (randomCode == 0) randomCode = 'a'
	else if (randomCode == 1) randomCode = 'b'
	else randomCode = 'c'
	piecePic += null
	for (i in 1..15) piecePic += javax.imageio.ImageIO.read(new File("images/sexpuzzles/" + randomCode + i + ".png"))

	def posX = []
	def posY = []
	for (i in 0..15) {
		posX += (int)( 120 * (i % 4) )
		posY += (int)( 120 * Math.floor(i / 4) )
	}

	def startTime
	def finish = false

	graphics.drawImage(bg, 0, 0, null)
	for (i in 1..15) graphics.drawImage(piecePic[i], posX[i], posY[i], null)
	setImage(frameBuffer, false)

	show("This is how it should look like. Press the button to start.")
	showButton("Start")

	def k = 20
	while (k >= 0) {
		def d = getRandom(4)
		while (goDir[blank][d] == null) {
			++d
			if (d > 3) d = 0
		}

		def next = goDir[blank][d]
		pieces[blank] = pieces[next]
		pieces[next] = 0
		blank = next

		graphics.drawImage(bg, 0, 0, null)
		for (i in 0..15) {
			if (pieces[i] > 0)
				graphics.drawImage(piecePic[ pieces[i] ], posX[i], posY[i], null)
		}
		setImage(frameBuffer, false)

		if (k == 20) wait(1.0)
		else if (k == 19) wait(1.0)
		else if (k == 18) wait(1.0)
		else if (k == 17) wait(0.8)
		else if (k == 16) wait(0.8)
		else if (k == 15) wait(0.6)
		else if (k == 14) wait(0.6)
		else if (k == 13) wait(0.5)
		else if (k == 12) wait(0.4)
		else if (k == 11) wait(0.3)
		else if (k == 10) wait(0.2)
		else wait(0.1)

		k--
	}

	graphics.drawImage(bg, 0, 0, null)
	for (i in 0..15) {
		if (pieces[i] > 0)
			graphics.drawImage(piecePic[ pieces[i] ], posX[i], posY[i], null)
	}
	setImage(frameBuffer, false)

	(1..100).each {
		def d = getRandom(4)
		while (goDir[blank][d] == null) {
			++d
			if (d > 3) d = 0
		}

		def next = goDir[blank][d]
		pieces[blank] = pieces[next]
		pieces[next] = 0
		blank = next
	}

	startTime = getTime()

	while ( !finish ) {
		graphics.drawImage(bg, 0, 0, null)
		for (i in 0..15) {
			if (pieces[i] > 0)
				graphics.drawImage(piecePic[ pieces[i] ], posX[i], posY[i], null)
		}
		setImage(frameBuffer, false)

		def directions = []
		def dirStrings = []
		
		if (goDir[blank][right] != null) { 
			directions += right
			dirStrings += "Right"
		}

		if (goDir[blank][up] != null) { 
			directions += up
			dirStrings += "Up"
		}

		if (goDir[blank][left] != null) { 
			directions += left
			dirStrings += "Left"
		}

		if (goDir[blank][down] != null) { 
			directions += down
			dirStrings += "Down"
		}

		def d = getSelectedValue("", dirStrings)
		def next = goDir[blank][ directions[d] ]
		pieces[blank] = pieces[next]
		pieces[next] = 0
		blank = next

		finish = true 
		for (def i = 0; finish && i<16; ++i) finish = (i == pieces[i])  
	}

	def seconds = getTime()-startTime

	graphics.drawImage(bg, 0, 0, null)
	for (i in 1..15) graphics.drawImage(piecePic[i], posX[i], posY[i], null)
	setImage(frameBuffer, false)

	show("Good job!\nYou finished it in " + seconds + " seconds!")
	showButton("Okay")

	def rank = 1
	while (rank<11 && seconds >= loadInteger("sexpuzzles.highscore"+rank)) rank++

	if (rank < 11) {
		def rankStr = ""+rank+"th"
		if (rank == 1) rankStr = "first"
		else if (rank == 2) rankStr = "second"
		else if (rank == 3) rankStr = "third"

		def name = getString("Congratulations!!\nYou ranked "+rankStr+"!\nPlease enter your name","")

		for (def i = 10; i > rank; --i) {
			save("sexpuzzles.highscore"+i, loadInteger("sexpuzzles.highscore"+(i-1)))
			save("sexpuzzles.highscoreName"+i, loadString("sexpuzzles.highscoreName"+(i-1)))
		}

		save("sexpuzzles.highscore"+rank, seconds)
		save("sexpuzzles.highscoreName"+rank, name)
	}
	

	setImage("sexpuzzles/Title.png")
	show("")
}

action = getSelectedValue("", ["New Game", "Highscores", "Exit"] )
}

setImage(null)
show("")
return null

//// CreativeCommons by-NC licensed script. See http://creativecommons.org/licenses/by-nc/3.0/ for more details  //////
